package PresentationLayer;

import DataLayer.settings;
import FunctionLayer.Datahandler;
import FunctionLayer.PipelineJMWESingleton;
import discord4j.core.DiscordClient;
import discord4j.core.GatewayDiscordClient;
import discord4j.core.event.domain.message.MessageCreateEvent;
import discord4j.core.object.entity.Sticker;
import discord4j.core.object.entity.User;
import discord4j.core.object.entity.channel.TextChannel;
import edu.stanford.nlp.pipeline.StanfordCoreNLP;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.*;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;


/**
 * @author install1
 */
public class DiscordHandler {

    private static void receiveAndSendPacket(DatagramSocket serverSocket, InetAddress ipAddress, int port,
                                             Datahandler datahandler, StanfordCoreNLP stanfordCoreNLP, StanfordCoreNLP stanfordCoreNLPSentiment) throws IOException {
        byte[] receiveData = new byte[4096];
        DatagramPacket receivePacket = new DatagramPacket(receiveData, receiveData.length);
        try {
            serverSocket.receive(receivePacket);
        } catch (IOException e) {
            e.printStackTrace();
        }
        String sentence = new String(receivePacket.getData(), 0,
                receivePacket.getLength());
        sentence = sentence.replace("clientmessage:", "");
        String ResponseMsg = datahandler.getResponseMsg(sentence, "", stanfordCoreNLP, stanfordCoreNLPSentiment,
                true);
        byte[] sendData = ResponseMsg.getBytes("UTF-8");
        int deliver_port = 0;
        switch (port) {
            case 48475:
                deliver_port = 48470;
                break;
            case 48476:
                deliver_port = 48471;
                break;
            case 48477:
                deliver_port = 48472;
                break;
            case 48478:
                deliver_port = 48473;
                break;
        }
        DatagramPacket sendPacket = new DatagramPacket(sendData, sendData.length, ipAddress, deliver_port);
        serverSocket.send(sendPacket);
    }

    public static void handleUDPTraffic(int port, Datahandler datahandler,
                                        StanfordCoreNLP stanfordCoreNLP, StanfordCoreNLP stanfordCoreNLPSentiment) {

        try (DatagramSocket serverSocket = new DatagramSocket(port)) {

            String hostIP = "195.154.53.196";
            if (port == 48477 || port == 48478) {
                hostIP = "51.158.20.245";
            }
            InetAddress ipAddress = InetAddress.getByName(hostIP);//used ip'
            while (true) {
                receiveAndSendPacket(serverSocket, ipAddress, port, datahandler, stanfordCoreNLP, stanfordCoreNLPSentiment);
            }
        } catch (SocketException | UnknownHostException e) {
            e.printStackTrace();
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    //TODO add python program that edits the java code. python program just adds test if statements on
    //variables until the tests pass
    public static void main(String[] args) throws IOException, SQLException {
        Datahandler datahandler = new Datahandler();

        PipelineJMWESingleton.getINSTANCE();
        StanfordCoreNLP stanfordCoreNLP = datahandler.pipeLineSetUp();
        StanfordCoreNLP stanfordCoreNLPSentiment = datahandler.shiftReduceParserInitiate();
        System.out.println("FINISHED ALL ANNOTATIONS");
        System.out.println("updatedstring cache");
        String token = new settings().getDiscordToken();
        final DiscordClient client = DiscordClient.create(token);
        final GatewayDiscordClient gateway = client.login().block();
        String usernameBot = gateway.getSelf().block().getUsername();
        int autismbotCount = 4;
        //make sure not to use ports that are already occupied.
        for (int i = 0; i < autismbotCount; i++) {
            final int j = i;
            new Thread(() -> {
                ArrayList<Integer> ports = new ArrayList<Integer>();
                ports.add(48475);
                ports.add(48476);
                ports.add(48477);
                ports.add(48478);
                handleUDPTraffic(ports.get(j), datahandler, stanfordCoreNLP, stanfordCoreNLPSentiment);
            }).start();
        }
        gateway.on(MessageCreateEvent.class).subscribe(event -> {
            String username = "";
            try {
                username = event.getMessage().getAuthor().get().getUsername();
            } catch (java.util.NoSuchElementException e) {
                username = null;
            }
            //System.out.println("past event.getMessage().getAuthor().get().getUsername()");
            List<User> blockLast = event.getMessage().getUserMentions();
            String content = event.getMessage().getContent();
            if (blockLast != null) {
                for (User user : blockLast) {
                    content = content.replace(user.getId().asString(), "");
                }
            }
            //System.out.println("past event.getMessage().getContent()");

            if (username != null && !username.equals(usernameBot) && !content.isEmpty()) {
                TextChannel block = event.getMessage().getChannel().cast(TextChannel.class).block();
                String name = block.getCategory().block().getName();
                name = name.toLowerCase();
                String channelName = block.getName().toLowerCase();
                boolean channelpermissionsDenied = false;
                if (channelName.contains("suggestion-box")) {
                    channelpermissionsDenied = true;
                }
                switch (name) {
                    case "public area":
                    case "information area": {
                        break;
                    }
                    default: {
                        channelpermissionsDenied = true;
                        break;
                    }
                }
                if (!channelpermissionsDenied) {
                    //System.out.println("past !channelpermissionsDenied");
                    boolean mentionedBot = false;
                    if (blockLast != null) {
                        for (User user : blockLast) {
                            if (user.getUsername().equals(usernameBot)) {
                                mentionedBot = true;
                                break;
                            }
                        }
                    }
                    if (mentionedBot || channelName.contains("general-autism")) {
                        String ResponseStr;
                        ResponseStr = datahandler.getResponseMsg(content, username, stanfordCoreNLP, stanfordCoreNLPSentiment,
                                false);
                        if (!ResponseStr.isEmpty()) {
                            System.out.print("\nResponseStr3: " + ResponseStr + "\n");
                            event.getMessage().getChannel().flatMap(chan -> chan.createMessage(ResponseStr)).block();
                            //event.getMessage().getChannel().block().createMessage(ResponseStr).block();
                            //System.out.print("past event.getMessage().getChannel()");
                        }
                    } else {
                        //System.out.println("pre else statement trimString");
                        String strF = datahandler.trimString(content);
                        //System.out.println("post else statement trimString. strf: " + strF);
                        datahandler.getResponseFutures(strF, stanfordCoreNLP, stanfordCoreNLPSentiment);
                    }
                }
            }
        });
        gateway.onDisconnect().block();
    }
}
